Debian Bug report logs - #77563
cron: crontab(5) lies, '@reboot' is whenever cron restarts, not the system

version graph

Package: cron; Maintainer for cron is Javier Fernández-Sanguino Peña <jfs@debian.org>; Source for cron is src:cron.

Reported by: James Troup <james@nocrew.org>

Date: Mon, 20 Nov 2000 21:48:02 UTC

Severity: normal

Found in version 3.0pl1-57.1

Fixed in version cron/3.0pl1-62

Done: Steve Greenland <stevegr@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Steve Greenland <stevegr@debian.org>:
Bug#77563; Package cron. Full text and rfc822 format available.

Acknowledgement sent to James Troup <james@nocrew.org>:
New Bug report received and forwarded. Copy sent to Steve Greenland <stevegr@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: James Troup <james@nocrew.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: cron: crontab(5) lies, '@reboot' is whenever cron restarts, not the system
Date: Mon, 20 Nov 2000 21:38:02 +0000
Package: cron
Version: 3.0pl1-57.1
Severity: normal

I just installed the cron security fix from s.d.o and all my @reboot
entries were run, when cron was restarted in the postinst, with some
(un)amusing consequences.  Either @reboot needs to be fixed to only
run on system restart or the crontab(5) manpage needs to be fixed...

-- System Information
Debian Release: 2.2
Architecture: i386
Kernel: Linux dtdebian 2.2.18pre9 #1 Sat Sep 16 19:26:20 BST 2000 i686

Versions of packages cron depends on:
ii  bsdutils                     1:2.10f-5.1 Basic utilities from 4.4BSD-Lite. 
ii  debianutils                  1.13.3      Miscellaneous utilities specific t
ii  libc6                        2.1.3-13    GNU C Library: Shared libraries an




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#77563; Package cron. Full text and rfc822 format available.

Acknowledgement sent to Steve Greenland <stevegr@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 77563@bugs.debian.org (full text, mbox):

From: Steve Greenland <stevegr@debian.org>
To: James Troup <james@nocrew.org>, 77563@bugs.debian.org
Subject: Re: Bug#77563: cron: crontab(5) lies, '@reboot' is whenever cron restarts, not the system
Date: Mon, 20 Nov 2000 18:57:38 -0600
On 20-Nov-00, 15:38 (CST), James Troup <james@nocrew.org> wrote: 
> Package: cron
> Version: 3.0pl1-57.1
> Severity: normal
> 
> I just installed the cron security fix from s.d.o and all my @reboot
> entries were run, when cron was restarted in the postinst, with some
> (un)amusing consequences.  Either @reboot needs to be fixed to only
> run on system restart or the crontab(5) manpage needs to be fixed...

The facetious answer: The crontab(5) manpage is exactly correct: it
doesn't say anything about system restart.

The annoying answer: why are you using @reboot? Put it in a sysvinit
script where it belongs.

The real answer: send a patch that reliable distinguishes between cron
restarts and system reboots and I'll include it. Since you ar the second
one to report this "problem" in the last couple weeks, my current
inclination is to remove the functionality, since it serves no useful
purpose (see previous answer).

Steve

-- 
Steve Greenland <stevegr@debian.org>



Information forwarded to debian-bugs-dist@lists.debian.org, Steve Greenland <stevegr@debian.org>:
Bug#77563; Package cron. Full text and rfc822 format available.

Acknowledgement sent to James Troup <james@nocrew.org>:
Extra info received and forwarded to list. Copy sent to Steve Greenland <stevegr@debian.org>. Full text and rfc822 format available.

Message #15 received at 77563@bugs.debian.org (full text, mbox):

From: James Troup <james@nocrew.org>
To: Steve Greenland <stevegr@debian.org>
Cc: 77563@bugs.debian.org
Subject: Re: Bug#77563: cron: crontab(5) lies, '@reboot' is whenever cron restarts, not the system
Date: 21 Nov 2000 01:13:19 +0000
Steve Greenland <stevegr@debian.org> writes:

> On 20-Nov-00, 15:38 (CST), James Troup <james@nocrew.org> wrote: 
> > Package: cron
> > Version: 3.0pl1-57.1
> > Severity: normal
> > 
> > I just installed the cron security fix from s.d.o and all my @reboot
> > entries were run, when cron was restarted in the postinst, with some
> > (un)amusing consequences.  Either @reboot needs to be fixed to only
> > run on system restart or the crontab(5) manpage needs to be fixed...
> 
> The facetious answer: The crontab(5) manpage is exactly correct: it
> doesn't say anything about system restart.

Oh, feh, you're right.  Sorry, I read what I wanted to read and not
what was actually there.  You have to admit though, the name is
misleading...
 
> The annoying answer: why are you using @reboot? Put it in a sysvinit
> script where it belongs.

Err, it's a user crontab on a box where I don't have r3wt?

> The real answer: send a patch that reliable distinguishes between
> cron restarts and system reboots and I'll include it. Since you ar
> the second one to report this "problem" in the last couple weeks, my
> current inclination is to remove the functionality, since it serves
> no useful purpose (see previous answer).

Err, please don't... I very much like the ability[1] even if it means
I have to protect my scripts from multiple invocations on
upgrades/random cron restarts.  How about (a) aliasing or renaming it
to @restart or @cronstart? (b) adding a note to the manpage to make it
explicit that it's really not on _system_ start?

-- 
James

[1] @reboot (in the system or cron startup sense) is the only way I
know of to get something running at system startup as a user on a box
with no r3wt access.  If someone knows a better one, please share...



Information forwarded to debian-bugs-dist@lists.debian.org, Steve Greenland <stevegr@debian.org>:
Bug#77563; Package cron. Full text and rfc822 format available.

Acknowledgement sent to miquels@cistron.nl (Miquel van Smoorenburg):
Extra info received and forwarded to list. Copy sent to Steve Greenland <stevegr@debian.org>. Full text and rfc822 format available.

Message #20 received at submit@bugs.debian.org (full text, mbox):

From: miquels@cistron.nl (Miquel van Smoorenburg)
To: submit@bugs.debian.org
Subject: Re: Bug#77563: cron: crontab(5) lies, '@reboot' is whenever cron restarts, not the system
Date: 21 Nov 2000 02:02:20 GMT
In article <20001120185738.B6188@molehole.moregruel.net>,
Steve Greenland  <stevegr@debian.org> wrote:
>The real answer: send a patch that reliable distinguishes between cron
>restarts and system reboots and I'll include it. Since you ar the second
>one to report this "problem" in the last couple weeks, my current
>inclination is to remove the functionality, since it serves no useful
>purpose (see previous answer).

Check if /var/run/cron.boot exists. If not, touch it and run @reboot
commands.

Mike.



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#77563; Package cron. Full text and rfc822 format available.

Acknowledgement sent to Steve Greenland <stevegr@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #25 received at 77563@bugs.debian.org (full text, mbox):

From: Steve Greenland <stevegr@debian.org>
To: Miquel van Smoorenburg <miquels@cistron.nl>, 77563@bugs.debian.org
Subject: Re: Bug#77563: cron: crontab(5) lies, '@reboot' is whenever cron restarts, not the system
Date: Mon, 20 Nov 2000 21:31:47 -0600
On 20-Nov-00, 20:02 (CST), Miquel van Smoorenburg <miquels@cistron.nl> wrote: 
> Check if /var/run/cron.boot exists. If not, touch it and run @reboot
> commands.

Ah, great minds think alike (I just sent James a message with a similar
idea.)o

Thanks,
Steve

-- 
Steve Greenland <stevegr@debian.org>



Reply sent to Steve Greenland <stevegr@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to James Troup <james@nocrew.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #30 received at 77563-close@bugs.debian.org (full text, mbox):

From: Steve Greenland <stevegr@debian.org>
To: 77563-close@bugs.debian.org
Subject: Bug#77563: fixed in cron 3.0pl1-62
Date: Sun, 28 Jan 2001 14:54:42 -0500
We believe that the bug you reported is fixed in the latest version of
cron, which has been installed in the Debian FTP archive:

cron_3.0pl1-62_i386.deb
  to pool/main/c/cron/cron_3.0pl1-62_i386.deb
cron_3.0pl1-62.diff.gz
  to pool/main/c/cron/cron_3.0pl1-62.diff.gz
cron_3.0pl1-62.dsc
  to pool/main/c/cron/cron_3.0pl1-62.dsc
A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 77563@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Steve Greenland <stevegr@debian.org> (supplier of updated cron package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Sat, 27 Jan 2001 17:01:43 -0600
Source: cron
Binary: cron
Architecture: source i386
Version: 3.0pl1-62
Distribution: unstable
Urgency: medium
Maintainer: Steve Greenland <stevegr@debian.org>
Changed-By: Steve Greenland <stevegr@debian.org>
Description: 
 cron       - management of regular background processing
Closes: 51202 57356 64198 74762 77353 77563
Changes: 
 cron (3.0pl1-62) unstable; urgency=medium
 .
   * Change tracking of crontab directory mod times to deal with directories
   with mtimes in the future. Thanks to Florian Lohoff for tracking down
   the cause of this rare yet long-standing bug.
   (closes:#51202, #57356, #64198, #77353)
   * Run @reboot jobs only on reboot instead of cron restart.
   (closes:#74762, #77563)
   * Clarify which directory the lost+found files are in.
   * Protect against reading other people's crontabs via temp file symlink
   in crontab -e.
Files: 
 cfb31f7710a1de6628f384f6fd5709f7 603 admin important cron_3.0pl1-62.dsc
 339e0cf17d026cc563523e5fb2de581d 37514 admin important cron_3.0pl1-62.diff.gz
 9371f405dc862d7e0b86f1cab885f899 53262 admin important cron_3.0pl1-62_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.4 (GNU/Linux)
Comment: For info see http://www.gnupg.org

iD8DBQE6c17odiZsUPux21MRAjM/AJ9OMZ/J4Ac6vQ2cdzht+gX4uZHenACdGqzR
YmdVuNDwy5jhARR4dVD+q68=
=746O
-----END PGP SIGNATURE-----



Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 09:51:43 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.